'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _Panel = require('../../styles/cspace-layout/Panel.css');

var _Panel2 = _interopRequireDefault(_Panel);

var _PanelButtonBar = require('../../styles/cspace-layout/PanelButtonBar.css');

var _PanelButtonBar2 = _interopRequireDefault(_PanelButtonBar);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var propTypes = {
  buttons: _propTypes2.default.arrayOf(_propTypes2.default.node),
  children: _propTypes2.default.node,
  className: _propTypes2.default.string,
  collapsible: _propTypes2.default.bool,
  collapsed: _propTypes2.default.bool,
  color: _propTypes2.default.string,
  header: _propTypes2.default.node,
  name: _propTypes2.default.string,
  onToggleCollapsed: _propTypes2.default.func
};

var defaultProps = {
  collapsible: false,
  collapsed: false,
  color: 'black'
};

var Panel = function (_Component) {
  _inherits(Panel, _Component);

  function Panel(props) {
    _classCallCheck(this, Panel);

    var _this = _possibleConstructorReturn(this, (Panel.__proto__ || Object.getPrototypeOf(Panel)).call(this, props));

    _this.handleHeaderClick = _this.handleHeaderClick.bind(_this);
    return _this;
  }

  _createClass(Panel, [{
    key: 'handleHeaderClick',
    value: function handleHeaderClick() {
      var _props = this.props,
          collapsible = _props.collapsible,
          collapsed = _props.collapsed,
          name = _props.name,
          onToggleCollapsed = _props.onToggleCollapsed;


      if (collapsible && onToggleCollapsed) {
        onToggleCollapsed(name, !collapsed);
      }
    }
  }, {
    key: 'renderHeader',
    value: function renderHeader() {
      var _props2 = this.props,
          buttons = _props2.buttons,
          header = _props2.header;


      if (!header) {
        return null;
      }

      var buttonBar = null;

      if (buttons && buttons.length > 0) {
        buttonBar = _react2.default.createElement(
          'div',
          { className: _PanelButtonBar2.default.common },
          buttons
        );
      }

      return _react2.default.createElement(
        'header',
        null,
        _react2.default.createElement(
          'button',
          { type: 'button', onClick: this.handleHeaderClick },
          header
        ),
        buttonBar
      );
    }
  }, {
    key: 'renderBody',
    value: function renderBody() {
      var _props3 = this.props,
          collapsible = _props3.collapsible,
          collapsed = _props3.collapsed,
          children = _props3.children;


      if (collapsible && collapsed) {
        return null;
      }

      return _react2.default.createElement(
        'div',
        null,
        children
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var header = this.renderHeader();
      var body = this.renderBody();

      var _props4 = this.props,
          className = _props4.className,
          collapsible = _props4.collapsible,
          collapsed = _props4.collapsed,
          color = _props4.color;


      var classes = (0, _classnames2.default)(className, _Panel2.default.common, _Panel2.default[color], collapsible && collapsed ? _Panel2.default.collapsed : '');

      return _react2.default.createElement(
        'section',
        { className: classes },
        header,
        body
      );
    }
  }]);

  return Panel;
}(_react.Component);

exports.default = Panel;


Panel.propTypes = propTypes;
Panel.defaultProps = defaultProps;