'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactVirtualized = require('react-virtualized');

var _Table = require('../../styles/cspace-layout/Table.css');

var _Table2 = _interopRequireDefault(_Table);

var _TableRow = require('../../styles/cspace-layout/TableRow.css');

var _TableRow2 = _interopRequireDefault(_TableRow);

require('!style-loader!css-loader!react-virtualized/styles.css');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }
/* eslint-disable import/imports-first, import/no-unresolved */


/* eslint-enable import/imports-first, import/no-unresolved */

var propTypes = {
  columns: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    label: _propTypes2.default.string,
    dataKey: _propTypes2.default.string,
    width: _propTypes2.default.number
  })),
  showCheckboxColumn: _propTypes2.default.bool,
  renderCheckbox: _propTypes2.default.func,
  onRowClick: _propTypes2.default.func
};

var defaultProps = {
  columns: []
};

var rowClassName = function rowClassName(_ref) {
  var index = _ref.index;

  if (index >= 0) {
    return index % 2 === 0 ? _TableRow2.default.even : _TableRow2.default.odd;
  }

  return null;
};

var cellRenderer = function cellRenderer(_ref2) {
  var cellData = _ref2.cellData;
  return cellData;
};

var Table = function (_Component) {
  _inherits(Table, _Component);

  function Table(props) {
    _classCallCheck(this, Table);

    var _this = _possibleConstructorReturn(this, (Table.__proto__ || Object.getPrototypeOf(Table)).call(this, props));

    _this.handleRowClick = _this.handleRowClick.bind(_this);
    return _this;
  }

  _createClass(Table, [{
    key: 'handleRowClick',
    value: function handleRowClick(_ref3) {
      var index = _ref3.index;
      var onRowClick = this.props.onRowClick;


      if (onRowClick) {
        onRowClick(index);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          columns = _props.columns,
          renderCheckbox = _props.renderCheckbox,
          showCheckboxColumn = _props.showCheckboxColumn,
          remainingProps = _objectWithoutProperties(_props, ['columns', 'renderCheckbox', 'showCheckboxColumn']);

      var checkboxColumn = void 0;

      if (showCheckboxColumn) {
        checkboxColumn = _react2.default.createElement(_reactVirtualized.Column, {
          key: 'check',
          dataKey: 'selected',
          disableSort: true,
          cellRenderer: renderCheckbox,
          width: 18,
          flexGrow: 0,
          flexShrink: 0
        });
      }

      return _react2.default.createElement(
        _reactVirtualized.AutoSizer,
        null,
        function (_ref4) {
          var height = _ref4.height,
              width = _ref4.width;
          return _react2.default.createElement(
            _reactVirtualized.Table,
            _extends({}, remainingProps, {
              className: _Table2.default.common,
              width: width,
              height: height,
              headerHeight: 22,
              rowHeight: 22,
              rowClassName: rowClassName,
              tabIndex: null,
              onRowClick: _this2.handleRowClick
            }),
            checkboxColumn,
            columns.map(function (column) {
              return _react2.default.createElement(_reactVirtualized.Column, _extends({
                key: column.dataKey,
                cellRenderer: cellRenderer
              }, column));
            })
          );
        }
      );
    }
  }]);

  return Table;
}(_react.Component);

exports.default = Table;


Table.SORT_ASC = _reactVirtualized.SortDirection.ASC;
Table.SORT_DESC = _reactVirtualized.SortDirection.DESC;

Table.propTypes = propTypes;
Table.defaultProps = defaultProps;